<template lang="pug">
div
	q-breadcrumbs(gutter="sm").q-mb-lg
		q-breadcrumbs-el(icon="home" to="/")
		q-breadcrumbs-el(label="Кухня" to="/kitchen")
		q-breadcrumbs-el(label="Ингредиенты" to="/kitchen/ingredients")
		q-breadcrumbs-el(:label="newItem ? 'Новый ингредиент' : 'Редактирование ингредиента'")

	.inner.q-py-md
		q-form.q-gutter-md(@submit="onSubmit")
			ui-input-text(v-model="item.name", label="Название ингредиента", required, :loading="loading")

			ui-uploader-image(
				v-model="item.visual",
				label="Изображение",
				:rules="[ val => val && val.length > 0 || 'Необходимо добавить изображение ингредиента']"
			)

			q-btn(
				:label="newItem ? 'Добавить ингредиент' : 'Сохранить ингредиент'",
				type="submit",
				color="primary"
				:loading="loading"
			)


</template>

<script lang="ts">
	import { defineComponent, onMounted, ref, computed } from 'vue'
	import { mapWritableState } from 'pinia'
	import { IIngredient } from '@/plugins/utils/types'
	import { useRouter } from 'vue-router'
	import UiUploaderImage from '@/components/ui/UiUploaderImage.vue'
	import UiInputText from '@/components/ui/UiInputText.vue'
	import { useKitchenIngredientsStore } from '@/pages/kitchen/children/ingredients/store'
	import { useQuasar } from 'quasar'

	export default defineComponent({
		name: 'PageKitchenIngredientsItem',

		props: ['id'],

		components: {
			UiUploaderImage,
			UiInputText,
		},

		setup(props) {
			const $q = useQuasar()
			const newItem = ref(props.id === undefined)
			const store = useKitchenIngredientsStore()
			const router = useRouter()

			onMounted(() => {
				store.getIngredientById(props.id)
			})

			return {
				newItem,
				loading: computed(() => store.loading),
				async onSubmit() {
					const { id } = (await store.saveIngredientItem()) as IIngredient
					await router.push(`/kitchen/ingredients/${id}`)
					$q.notify({
						color: 'positive',
						message: newItem.value ? 'Новый ингредиент добавлен' : 'Изменения сохранены',
					})
				},
			}
		},

		computed: {
			...mapWritableState(useKitchenIngredientsStore, {
				item: 'item',
			}),
		},
	})
</script>
